<?php
require_once 'controllers/BaseController.php';
require_once 'models/Member.php';
require_once 'models/WebProperty.php';

class IndexController extends BaseController
{

    public function indexAction()
    {
        $this->view->token = $this->generateToken();
        $this->_helper->layout()->body_onload='onload="document.mainform.url.focus();"';
        $flash = $this->_helper->getHelper('flashMessenger');
        
        if ($flash->hasMessages()) {
            $this->view->layout()->message = implode("<br />", $flash->getMessages());            
        } // if ($flash->hasMessages())
        
        $this->view->layout()->pageTitle = "Home";
        
        return;
    } // public function indexAction()
    
    
    public function riaAction()
    {
        $this->view->token = $this->generateToken();
        $flash = $this->_helper->getHelper('flashMessenger');
        if ($flash->hasMessages()) {
            $this->view->layout()->message = implode("<br />", $flash->getMessages());            
        } // if ($flash->hasMessages())
        
        $this->view->headTitle()->prepend('RIA version of ');
        
        $this->view->headScript('file',"/js/prototype.js");
        $this->view->headScript('file',"/js/scriptaculous.js");
        $this->view->layout()->footer    = '';        
        $this->view->layout()->pageTitle = "Ajaxified Home";
        return;
    } // public function indexAction()
    
    
    public function extractAction()
    {
        try {
            /*
             * get the token
             */
            $token = Zend_Filter::get($this->getRequest()->getPost('token'), 'StripTags');
            
            /*
             * Execute the token check
             */
            if (!$this->tokenCheck($token)) {
                throw new Zend_Exception("I'm sorry but I think there has been an error. Please try again.");
            } // if (!$this->tokenCheck($token))
            
            /*
             * Reset the token
             */
            $this->generateToken();
            
            /*
             * get the URL passed in from the form
             */
            $url = Zend_Filter::get($this->getRequest()->getPost('url'), 'StripTags');
            
            /*
             * Create the web property and save it. If we don't save it here,
             * analyze won't save our resultset.
             */
            $wp  = new WebProperty($url);
            $wp->save();
            
            /*
             * Hand everyhing off to the view for output
             */
            $this->view->url = $url ;        
            $this->view->result = $wp->analyze();
            $this->view->headTitle()->append(' : Extraction Results Page');
            
            $this->view->layout()->pageTitle = "Extraction Results";
            
        } catch (Zend_Exception $e) {
            /*
             * Deal with exceptions.
             */
            $this->_helper->flashMessenger->addMessage("There was an error processing your request.");
            $this->_helper->flashMessenger->addMessage("Exception Type:".get_class($e));
            $this->_helper->flashMessenger->addMessage("Exception Message:".$e->getMessage());
            $this->_redirect('/index/index');
            return false;
        } // try
        
        return true;            
    } // public function extractAction()
    
    
    public function loginAction()
    {
        $this->view->token = $this->generateToken();
        
        $flash = $this->_helper->getHelper('flashMessenger');
        if ($flash->hasMessages()) {
            $this->view->layout()->message = implode("<br />", $flash->getMessages());            
        } // if ($flash->hasMessages()) 
        $this->view->layout()->pageTitle = "Log In";
        return;
    } // public function loginAction()
    
    
    public function registerAction()
    {
        $this->view->token = $this->generateToken();
        $this->_helper->layout()->body_onload='onload="document.mainform.emailAddress.focus();"';
        
        $flash = $this->_helper->getHelper('flashMessenger');
        if ($flash->hasMessages()) {
            $this->view->message = implode("<br />", $flash->getMessages());            
        } // if ($flash->hasMessages())
        $this->view->layout()->pageTitle = "Register";
        
        return;
    }
    

} // class IndexController extends Zend_Controller_Action