<?php
require_once 'controllers/BaseController.php';

class IndexController extends BaseController
{
    public function indexAction()
    {
        $this->view->token = $this->generateToken();
        $flash = $this->_helper->getHelper('flashMessenger');
        if ($flash->hasMessages()) {
            $this->view->message = implode("<br />", $flash->getMessages());            
        } // if ($flash->hasMessages()) 
        
    } // public function indexAction()
    
    public function extractAction()
    {
        /*
         * get the token
         */
        $token = Zend_Filter::get($this->getRequest()->getPost('token'), 'StripTags');
        
        /*
         * Execute the token check
         */
        if (!$this->tokenCheck($token)) {
            $this->_helper->flashMessenger->addMessage("I'm sorry but I think there has been an error. Please try again.");
            $this->_redirect('/index/index');
            return false;
        } // if (!$this->tokenCheck($token))
        
        $this->generateToken();
        
        /*
         * get the URL passed in from the form
         */
        $url = Zend_Filter::get($this->getRequest()->getPost('url'), 'StripTags');
        
        /*
         * read page into memory
         * requires allow_url_fopen to be true
         */
        $page = file_get_contents($url);
        
        /*
         * stirp out everything but the content
         * Many thanks to #phpc members ds3 and SlashLife for the RegEx
         */
        $matches = array();
        preg_match('/<body[^>]*>(.*?)<\/body\s*/isx', $page, $matches);
        $content = $matches[1];

        /*
         * Filter out the cruft
         */
        $content = preg_replace('/(<style[^>]*>[^>]*<\/style\s*>)/isx', '', $content);
        $content = preg_replace('/(<script[^>]*>[^>]*<\/script\s*>)/isx', '', $content);
        $content = preg_replace('/(&.*?;)/isx', '', $content);
        
        $content = Zend_Filter::get($content, 'StripTags');

        
        /*
         * send it off to Yahoo for analysis
         */
        $client = new Zend_Rest_Client('http://search.yahooapis.com/ContentAnalysisService/V1/termExtraction');
        $client->appid('rqP7px3V34H2DVtFJq04ZFTHfiRJQmlvnQze4T313MFEGLAy1.lw8PZBWeRqk40R_30-')
               ->context($content)
               ->output('xml');
        $result = $client->post();
        $client = null;
        
        /*
         * Hand everthing off to the view for output
         */
        $this->view->url = $url ;        
        $this->view->result = $result->Result ;
        
        return;
    } // public function extractAction()
    
} // class IndexController extends Zend_Controller_Action