<?php
require_once 'controllers/BaseController.php';
require_once 'models/Member.php';

class IndexController extends BaseController
{


    public function indexAction()
    {
        $this->view->token = $this->generateToken();
        $flash = $this->_helper->getHelper('flashMessenger');
        if ($flash->hasMessages()) {
            $this->view->message = implode("<br />", $flash->getMessages());            
        } // if ($flash->hasMessages()) 
    } // public function indexAction()
    
    public function extractAction()
    {
        /*
         * get the token
         */
        $token = Zend_Filter::get($this->getRequest()->getPost('token'), 'StripTags');
        
        /*
         * Execute the token check
         */
        if (!$this->tokenCheck($token)) {
            $this->_helper->flashMessenger->addMessage("I'm sorry but I think there has been an error. Please try again.");
            $this->_redirect('/index/index');
            return false;
        } // if (!$this->tokenCheck($token))
        
        $this->generateToken();
        
        /*
         * get the URL passed in from the form
         */
        $url = Zend_Filter::get($this->getRequest()->getPost('url'), 'StripTags');
        
        /*
         * read page into memory
         * requires allow_url_fopen to be true
         */
        $page = file_get_contents($url);
        
        /*
         * stirp out everything but the content
         * Many thanks to #phpc members ds3 and SlashLife for the RegEx
         */
        $matches = array();
        preg_match('/<body[^>]*>(.*?)<\/body\s*/isx', $page, $matches);
        $content = $matches[1];

        /*
         * Filter out the cruft
         */
        $content = preg_replace('/(<style[^>]*>[^>]*<\/style\s*>)/isx', '', $content);
        $content = preg_replace('/(<script[^>]*>[^>]*<\/script\s*>)/isx', '', $content);
        $content = preg_replace('/(&.*?;)/isx', '', $content);
        
        $content = Zend_Filter::get($content, 'StripTags');

        
        /*
         * send it off to Yahoo for analysis
         */
        $client = new Zend_Rest_Client('http://search.yahooapis.com/ContentAnalysisService/V1/termExtraction');
        $client->appid('rqP7px3V34H2DVtFJq04ZFTHfiRJQmlvnQze4T313MFEGLAy1.lw8PZBWeRqk40R_30-')
               ->context($content)
               ->output('xml');
        $result = $client->post();
        $client = null;
        
        /*
         * Hand everthing off to the view for output
         */
        $this->view->url = $url ;        
        $this->view->result = array();
        foreach($result->Result as $item) {
            $this->view->result[] = (string)$item;
        } // foreach($result->Result as $item) 
                
        return;
    } // public function extractAction()
    
    public function loginAction()
    {
        $this->view->token = $this->generateToken();
        
        $flash = $this->_helper->getHelper('flashMessenger');
        if ($flash->hasMessages()) {
            $this->view->message = implode("<br />", $flash->getMessages());            
        } // if ($flash->hasMessages()) 
        
    }
    
    public function registerAction()
    {
        $this->view->token = $this->generateToken();

        $flash = $this->_helper->getHelper('flashMessenger');
        if ($flash->hasMessages()) {
            $this->view->message = implode("<br />", $flash->getMessages());            
        } // if ($flash->hasMessages()) 
        
    }
    
    public function testDBaction() {
        $this->_helper->viewRenderer->setNoRender(true);
        
        $db = Zend_Db::factory('Pdo_Mysql', array(
                               'host'     => '127.0.0.1',
                               'username' => 'example',
                               'password' => 'example',
                               'dbname'   => 'example3',
                               'profiler'=>true));
                               
        echo '<pre>';
        $sql = "select * from member";
        echo "<h2>fetchAll()</h2>";
        print_r($db->fetchAll($sql));
        echo "<h2>fetchAssoc()</h2>";
        print_r($db->fetchAssoc($sql));
        echo "<h2>fetchCol()</h2>";
        print_r($db->fetchCol($sql));
        echo "<h2>fetchPairs()</h2>";
        
        print_r($db->fetchPairs("select firstName, lastName from member"));
        echo "<h2>fetchRow()</h2>";
        print_r($db->fetchRow($sql));
        echo "<h2>fetchOne()</h2>";
        var_dump($db->fetchOne("select emailAddress from member where id=4"));
        
        echo "<hr /><table border='1'><tr><th>Query #</th><th>Time</th><th>Query</th></tr>";
        $profiler     = $db->getProfiler();
        $totalTime    = $profiler->getTotalElapsedSecs();
        $queryCount   = $profiler->getTotalNumQueries();
        $longestTime  = 0;
        $longestQuery = null;        
        $count        = 0;
        
        foreach ($profiler->getQueryProfiles() as $query) {
            echo "<tr>";
            echo "<td>".$count++."</td>";
            echo "<td>".$query->getElapsedSecs()."</td>";
            echo "<td>".$query->getQuery()."</td>";
            if ($query->getElapsedSecs() > $longestTime) {
                $longestTime  = $query->getElapsedSecs();
                $longestQuery = $query->getQuery();
            } // if ($query->getElapsedSecs() > $longestTime)
            echo "</tr>";
        } // foreach ($profiler->getQueryProfiles() as $query)
        echo "</table>";


        echo 'Total Queries Executed : ' . $queryCount . "\n";
        echo 'Total Time             : ' . $totalTime . ' seconds' . "\n";
        echo 'Average query length   : ' . $totalTime / $queryCount . ' seconds' . "\n";
        echo 'Queries per second     : ' . $queryCount / $totalTime . "\n";
        echo 'Longest query length   : ' . $longestTime . "\n";
        echo "Longest query          : \n" . $longestQuery . "\n";
        echo '</pre>';
    }
} // class IndexController extends Zend_Controller_Action