<?php
require_once 'controllers/BaseController.php';
require_once 'models/Member.php';

class MemberController extends BaseController
{
    public function indexAction()
    {
    }

    public function processLoginAction()
    {
        /*
         * get the token
         */
        $token = Zend_Filter::get($this->getRequest()->getPost('token'), 'StripTags');
        
        /*
         * Execute the token check
         */
        if (!$this->tokenCheck($token)) {
            $this->_helper->flashMessenger->addMessage("I'm sorry but I think there has been an error. Please try again.");
            $this->_redirect('/index/login');
            return false;
        } // if (!$this->tokenCheck($token))
        
        /*
         * Invalidate the token
         */
        $this->generateToken();
        
        $this->_helper->viewRenderer->setNoRender(true);
        
        
        /*
         * Get the email address and password. 
         */
        $emailAddress = Zend_Filter::get($this->getRequest()->getPost('emailAddress'), 'StripTags');
        
        $passwordFilter = new Zend_Filter();
        $passwordFilter->addFilter(new Zend_Filter_HtmlEntities())
                       ->addFilter(new Zend_Filter_StripTags());
        $userPassword = $passwordFilter->filter($this->getRequest()->getPost('userPassword'), 'StripTags');

        if ($memberId=Member::login($emailAddress,$userPassword)) {
            $memberSession = new Zend_Session_Namespace('member');
            $memberSession->member = new Member($memberId);            
            $this->_helper->flashMessenger->addMessage("Welcome Back {$memberSession->member->firstName}.");
            $this->_redirect('/index/index');
        } else {
            $this->_helper->flashMessenger->addMessage("I'm sorry but there was a problem logging you in. Please try again.");
            $this->_redirect('/index/login');
        } // if ($memberId=Member::login($emailAddress,$userPassword))
        
    } // public function processloginAction()

    public function processRegisterAction()
    {
        /*
         * get the token
         */
        $token = Zend_Filter::get($this->getRequest()->getPost('token'), 'StripTags');
        
        /*
         * Execute the token check
         */
        if (!$this->tokenCheck($token)) {
            $this->_helper->flashMessenger->addMessage("I'm sorry but I think there has been an error. Please try again.");
            $this->_redirect('/index/login');
            return false;
        } // if (!$this->tokenCheck($token))
        
        $this->_helper->viewRenderer->setNoRender(true);
        
        /*
         * Get the email address and password. 
         */
        $emailAddress = Zend_Filter::get($this->getRequest()->getPost('emailAddress'), 'StripTags');
        $passwordFilter = new Zend_Filter();
        $passwordFilter->addFilter(new Zend_Filter_HtmlEntities())
                       ->addFilter(new Zend_Filter_StripTags());
        $userPassword = $passwordFilter->filter($this->getRequest()->getPost('userPassword'), 'StripTags');
        $firstName    = Zend_Filter::get($this->getRequest()->getPost('firstName'), 'StripTags');
        $lastName     = Zend_Filter::get($this->getRequest()->getPost('lastName'), 'StripTags');
        
        // if true then error
        if (Member::emailCheck($emailAddress)) {
            $this->_helper->flashMessenger->addMessage("I'm sorry but {$emailAddress} is taken already");
            $this->_redirect('/index/register');
        } // if (!Member::emailCheck($emailAddress))
        
        $member = new Member();
        $member->emailAddress = $emailAddress;
        $member->userPassword = $userPassword;
        $member->firstName    = $firstName;
        $member->lastName     = $lastName;
        
        $member->save();
        $this->_helper->flashMessenger->addMessage("Welcome to the system. You may now log in.");
        $this->_redirect('/index/index');
        
    } // public function registerAction()
    
} // class MemberController extends BaseController