<?php

class Member
{
    protected $_data;
    protected $_id;    
    public function __construct($memberId)
    {

        if ($memberId) {
            $this->load($memberId);
        } else {
            $this->_data = array('id'=>0,
                                 'emailAddress' => '',
                                 'userPassword' => '',
                                 'firstName'    => '',
                                 'lastName'     => '');
        } // if ($memberId) 
        
    } // public function __construct($memberId)
    
    
    public function load($memberId)
    {
        $db = Zend_Db::factory('Pdo_Mysql', array(
                               'host'     => '127.0.0.1',
                               'username' => 'example',
                               'password' => 'example',
                               'dbname'   => 'example3'));
        
        $sql = 'SELECT * FROM member WHERE id = ?';

        if ($result = $db->fetchRow($sql, array($memberId))) {
            $this->_data = $result;
            $this->_id = $memberId;
        } // if ($result = $db->fetchRow($sql, array($emailAddress,$userPassword)))
        return;
    }
    
    
    public function save()
    {
        $db = Zend_Db::factory('Pdo_Mysql', array(
                               'host'     => '127.0.0.1',
                               'username' => 'example',
                               'password' => 'example',
                               'dbname'   => 'example3'));
                               
        $data = array();
        $data['emailAddress'] = $this->emailAddress;
        $data['userPassword'] = $this->userPassword;
        $data['firstName'] = $this->firstName;
        $data['lastName'] = $this->lastName;
        if (!$this->_id) {
            $db->insert('member', $data);
            $this->_id = $db->lastInsertId();
        } else {
            $db->update('member', $data, 'id = '.(int)$this->_id);
        } // if ($memberId) 
        
    } // public function save()
    
    
    public static function login($emailAddress=null, $userPassword=null)
    {
        
        $returnValue = false;
        /*
         * Validate the email address
         */
        $emailValidator = new Zend_Validate_EmailAddress();
        
        /*
         * Email Address is invalid. Notify the user.
         */
        if (!$emailValidator->isValid($emailAddress)) {
            return false;
        } // if (!$validator->isValid($emailAddress))
        
        $db = Zend_Db::factory('Pdo_Mysql', array(
                               'host'     => '127.0.0.1',
                               'username' => 'example',
                               'password' => 'example',
                               'dbname'   => 'example3'));
        
        $db->getConnection();
        
        $sql = 'SELECT id FROM member WHERE emailAddress = ? and userPassword=?';

        if ($result= $db->fetchRow($sql,array($emailAddress,$userPassword))) {
            $returnValue = $result['id'];
        } // if ($result = $db->fetchRow($sql, array($emailAddress,$userPassword)))
        
        return $returnValue;
    }
    
    /*
     * return true if the email address is in the database, false if not or error.
     */
    public static function  emailCheck($emailAddress)
    {
        /*
         * Validate the email address
         */
        $emailValidator = new Zend_Validate_EmailAddress();
        
        /*
         * Email Address is invalid. Notify the user.
         */
        if (!$emailValidator->isValid($emailAddress)) {
                return false;
        } // if (!$validator->isValid($emailAddress))

        $db = Zend_Db::factory('Pdo_Mysql', array(
                               'host'     => '127.0.0.1',
                               'username' => 'example',
                               'password' => 'example',
                               'dbname'   => 'example3'));
        
        $db->getConnection();
        
        $sql = 'SELECT id FROM member WHERE emailAddress = ?';
        $result = $db->fetchRow($sql, array($emailAddress));
        
        if ($result) {
            return true;
        } else {
            return false;
        } // if ($result = $db->fetchRow($sql, array($emailAddress,$userPassword)))
        
    } // public static function  emailCheck($emailAddress)
    
    public function __get($index)
    {
        if (isset($this->_data[$index])) {
            return $this->_data[$index];
        }
        return null;
    }
    
    public function __set($index, $value)
    {
        if (isset($this->_data[$index])) {
            $this->_data[$index] = $value;
            return true;
        }
        return false;
    }
} // class Member
