<?php
require_once 'controllers/BaseController.php';
require_once 'models/Member.php';
require_once 'models/WebProperty.php';

class HistoryController extends BaseController
{
    protected $member = null;
    
    public function init()
    {
        parent::init();
        if (!$this->view->member) {
            $this->_helper->flashMessenger->addMessage("You must be logged in to access that page.");
            $this->_redirect('/index/index');
            return;
        }
        
        return;
    } // public function init()
    
    public function listSearchesAction()
    {
        $db = Zend_Db::factory('Pdo_Mysql', array(
                               'host'     => '127.0.0.1',
                               'username' => 'example',
                               'password' => 'example',
                               'dbname'   => 'example3'));
        $sql = 'select wp.id as wp_id,
                       wpa.id as wpa_id,
                       wpa.search_date,
                       wp.url
                  from web_property_analysis wpa,
                       web_property wp
                 where wpa.web_property_id = wp.id
                 order by url,
                          search_date;';
        if($results = $db->fetchAll($sql)) {
            $this->view->history = $results;
        } else {
            $this->view->history = array();
        } // if($results = $db->fetchAll($sql)) 
    } // public function listAction()
    
    
    public function listResultsAction()
    {
        /*
         * get the token
         */
        $wp_id  = (int)Zend_Filter::get($this->getRequest()->get('wpid'), 'StripTags');
        $wpa_id = (int)Zend_Filter::get($this->getRequest()->get('wpaid'), 'StripTags');
        $wp = new WebProperty($wp_id);
        $wp->loadAnalyzations();
        $this->view->results = $wp->fetchAnalysis($wpa_id);
    } // public function listResultsAction()
    
    
} // class HistoryController extends BaseController