<?php
require_once 'models/BaseModel.php';

class Member extends BaseModel
{

    public function __construct($memberId)
    {

        if ($memberId) {
            $this->load($memberId);
        } else {
            $this->_data = array('id'=>0,
                                 'emailAddress' => '',
                                 'userPassword' => '',
                                 'firstName'    => '',
                                 'lastName'     => '');
        } // if ($memberId) 
        
    } // public function __construct($memberId)
    
    
    public function load($memberId)
    {
        $db = $this->getDb();
        
        $sql = 'SELECT * FROM member WHERE id = ?';

        if ($result = $db->fetchRow($sql, array($memberId))) {
            $this->_data = $result;
            $this->_id = $memberId;
        } // if ($result = $db->fetchRow($sql, array($emailAddress,$userPassword)))
        return;
    }
    
    
    public function save()
    {
        $db = $this->getDb();
                               
        $data = array();
        $data['emailAddress'] = $this->emailAddress;
        $data['userPassword'] = $this->userPassword;
        $data['firstName'] = $this->firstName;
        $data['lastName'] = $this->lastName;
        if (!$this->_id) {
            $data['id'] = $this->_id;
            $db->insert('member', $data);
        } else {
            $db->update('member', $data, 'id = '.(int)$this->_id);
        } // if ($memberId) 
        
    } // public function save()
    
    
    public static function login($emailAddress=null, $userPassword=null)
    {
        
        $returnValue = false;
        /*
         * Validate the email address
         */
        $emailValidator = new Zend_Validate_EmailAddress();
        
        /*
         * Email Address is invalid. Notify the user.
         */
        if (!$emailValidator->isValid($emailAddress)) {
            return false;
        } // if (!$validator->isValid($emailAddress))
        
        /*
         * Get a database connection
         */
        $db = BaseModel::getDb();
        $db->getConnection();
        
        /*
         * setup authentication
         */
        $authAdapter  = new Zend_Auth_Adapter_DbTable($db);
        $authAdapter->setTableName('member')
                    ->setIdentityColumn('emailAddress')
                    ->setCredentialColumn('userPassword')
                    ->setIdentity($emailAddress)
                    ->setCredential($userPassword);
        
        /*
         * authenticate
         */
        $result = $authAdapter->authenticate();
        
        return $result->isValid();
    } // public static function login($emailAddress=null, $userPassword=null)
    
    /*
     * return true if the email address is in the database, false if not or error.
     */
    public static function  emailCheck($emailAddress)
    {
        /*
         * Validate the email address
         */
        $emailValidator = new Zend_Validate_EmailAddress();
        
        /*
         * Email Address is invalid. Notify the user.
         */
        if (!$emailValidator->isValid($emailAddress)) {
                return false;
        } // if (!$validator->isValid($emailAddress))

        $db = BaseModel::getDb();
                
        $sql = 'SELECT id FROM member WHERE emailAddress = ?';        
        $result = $db->fetchOne($sql, array($emailAddress));
        return (int)$result;
    
        
    } // public static function  emailCheck($emailAddress)

} // class Member
