<?php
require_once 'models/BaseModel.php';

class WebPropertyAnalysis extends BaseModel
{
    protected $_resultsList;
    
    public function __construct($id=-1)
    {

        if ((int)$id>0) {
            $this->load($id);
        } else {
            $this->_data = array('id'              => -1,
                                 'search_date'      => '',
                                 'web_property_id' => -1);
            $this->_resultsList = array();                     
        } // if ($id) 
        
    } // public function __construct($memberId)
    
    
    public function load($id)
    {
        $db = $this->getDb();

        $sql = 'SELECT *
                  FROM web_property_analysis
                 WHERE id = ?
                 ORDER BY search_date';
        if ($result = $db->fetchRow($sql, array($id))) {
            $this->_data = $result;
            
            $sql = 'SELECT *
                      FROM web_property_analysis_result
                     WHERE web_property_analysis_id = ?
                     ORDER BY display_position';
            $result = $db->fetchAll($sql, array($id));
            foreach($result as $key=>$data) {
                $this->_resultsList[] = $data['keyword'];
            }
        } // if ($result = $db->fetchRow($sql, array($id))) 
        return;
    } // public function load($id)
    
    
    public function save()
    {
        $db = $this->getDb();
                               
        $data = array();
        $data['search_date']      = $this->_data['search_date'];
        $data['web_property_id'] = $this->_data['web_property_id'];
        
        // NO UPDATES ALLOWED
        if (!$this->_id) {
            $db->insert('web_property_analysis', $data);
            $this->_id = $db->lastInsertId();
            foreach($this->_resultsList as $position=>$keyword) {
                $db->insert('web_property_analysis_result',
                            array('display_position'          => $position,
                                  'keyword'                  => $keyword,
                                  'web_property_analysis_id' => $this->_id));
                
            } // foreach($this->_resultsList as $position=>$word)
            
        } // if ($memberId) 
        
    } // public function save()
    
    public function addKeyWord($word)
    {
        $this->_resultsList[] = $word;
    } // public function addKeyWord($word)
    
    public function fetchResultsList()
    {
        return $this->_resultsList;
    }
} // class WebProperty extends BaseModel