<?php
require_once 'controllers/BaseController.php';

class ApiController extends BaseController
{

    public function init()
    {
        $this->_helper->viewRenderer->setNoRender();    
    } // public function init()
    
    public function fetchTopAction()
    {
        $limit  = (int)Zend_Filter::get($this->getRequest()->get('limit'), 'StripTags');
        
        $db = Globals::getDBConnection();
        
        $select = $db->select(array('keyword'))
                     ->from(array('wpa'=>'web_property_analysis_result'),array('keyword','keyword_count'=>'count(*)'))
                     ->group('wpa.keyword')
                     ->order(array('keyword_count DESC','keyword'))
                     ->limit($limit, 0);

        $results = $db->fetchAll($select);

        echo $this->toXML($results,'fetchTop',$limit);
        return;
    } // public function fetchTopAction()
    
    
    public function fetchTermAction()
    {
        $term  = Zend_Filter::get($this->getRequest()->get('term'), 'StripTags');
        
        $db = Globals::getDBConnection();
        
        $select = $db->select()
                     ->from(array('wpa'=>'web_property_analysis_result'),array('wpa.keyword','keyword_count'=>'count(*)'))
                     ->group('wpa.keyword')
                     ->where('keyword=?',$term);

        $results = $db->fetchAll($select);
        echo $this->toXML($results,'fetchTerm',$term);
        return;
    } // public function fetchTerm()


    public function toXml($dataArray,$callingMethod,$parameterValue)
    {
        
        $simpleXml = simplexml_load_string("<?xml version='1.0' encoding='utf-8'?><data />");
        $node = $simpleXml->addChild('results');
        $node->addChild('calling_method',$callingMethod);
        $node->addChild('parameter',$parameterValue);
        $node->addChild('row_count',count($dataArray));        
        
        foreach($dataArray as $keywordArray) {
            $node = $simpleXml->addChild('word');
            $node->addChild('keyword',$keywordArray['keyword']);
            $node->addChild('keyword_count',$keywordArray['keyword_count']);
        } // foreach($results as $keywordArray)
        
        $xml = $simpleXml->asXML();
        $simpleXml = null;
        
        return $xml;
    }

} // class ApiController extends BaseController
