<?php
require_once 'Zend/Loader.php';
Zend_Loader::loadClass('Zend_Cache');
Zend_Loader::loadClass('Zend_Db');
Zend_Loader::loadClass('Zend_Db_Table');
Zend_Loader::loadClass('Zend_Config_Ini');

class Globals
{
    
    private static $_db       = null;
    private static $_cache    = null;
    private static $_config   = null;
    
    public function __construct()
    {
        throw new Zend_Exception('You cannot instantiate Globals.php! It is static only.');
    }
    
    static public function getDBConnection()
    {
        if (self::$_db != null) {
            return self::$_db;
        } // if (self::$_db != null)
        
        self::$_db = Zend_Db::factory('Pdo_Mysql',
                                      array ('host'     => self::getConfig()->db->host,
                                             'username' => self::getConfig()->db->username,
                                             'password' => self::getConfig()->db->password,
                                             'dbname'   => self::getConfig()->db->dbname));
        Zend_Db_Table::setDefaultAdapter(self::$_db);
        return self::$_db;
    }


    static public function getCache()
    {
        if (self::$_cache != null) {
            return self::$_cache;
        } // if (self::$_db != null)
        
        self::$_cache =  Zend_Cache::factory('Core',
                                             'File',
                                             array('lifeTime'=>600,
                                                   'automatic_serialization'=>true),
                                                   array('cache_dir'=>self::getConfig()->dirs->cache));
        
        return self::$_cache;
    } // static public function getCache()

    public static function getConfig()
    {
        if (self::$_config != null) {
            return self::$_config;
        }
        
        self::$_config = new Zend_Config_Ini(
            dirname(__FILE__) . DIRECTORY_SEPARATOR . 'config.ini',
            'main',
            true);
        
        return self::$_config;
    } // public static function getConfig()

} // class Globals
