<?php

class ErrorController extends Zend_Controller_Action
{
    public function errorAction()
    {
        $errors = $this->_getParam('error_handler');
        /*
         * Output the proper header. 
         */
        switch ($errors->type) {
            case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_CONTROLLER:
            case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_ACTION:
                /*
                 * If we have no controller or action, return a 404 header.
                 */
                $this->getResponse()->setRawHeader('HTTP/1.1 404 Not Found');
                break;
            default:
                break;
        } // switch ($errors->type)
        
        $this->view->message = $errors->exception->getMessage();
        $this->view->trace   = $errors->exception->getTraceAsString();        
        $log = new Zend_Log(new Zend_Log_Writer_Stream(Globals::getConfig()->dirs->tmp.'Error.log'));
        $log->debug($errors->exception->getMessage() . "\n" .  $errors->exception->getTraceAsString());
        return;
    } // public function errorAction()
} // class ErrorController extends Zend_Controller_Action

