<?php
require_once 'controllers/BaseController.php';
require_once 'models/Member.php';
require_once 'models/WebProperty.php';

class IndexController extends BaseController
{
        
    public function indexAction()
    {
        //$fail = new Globals();
        $this->view->token = $this->generateToken();
        $flash = $this->_helper->getHelper('flashMessenger');
        if ($flash->hasMessages()) {
            $this->view->message = implode("<br />", $flash->getMessages());            
        } // if ($flash->hasMessages()) 
        
    } // public function indexAction()


    public function riaAction()
    {
        $this->view->token = $this->generateToken();
        $flash = $this->_helper->getHelper('flashMessenger');
        if ($flash->hasMessages()) {
            $this->view->message = implode("<br />", $flash->getMessages());            
        } // if ($flash->hasMessages()) 
        
    } // public function indexAction()

    
    public function extractAction()
    {
        try {
            /*
             * get the token
             */
            $token = Zend_Filter::get($this->getRequest()->getPost('token'), 'StripTags');
            
            /*
             * Execute the token check
             */
            if (!$this->tokenCheck($token)) {
                throw new Zend_Exception("I'm sorry but I think there has been an error. Please try again.");
            } // if (!$this->tokenCheck($token))
            
            /*
             * Reset the token
             */
            $this->generateToken();
            
            /*
             * get the URL passed in from the form
             */
            $url = Zend_Filter::get($this->getRequest()->getPost('url'), 'StripTags');
            $wp  = new WebProperty($url);
            $wp->save();
            
            /*
             * Hand everyhing off to the view for output
             */
            $this->view->url = $url ;        
            $this->view->result = $wp->analyze();

            $wp->save();
        } catch (Zend_Exception $e) {
            /*
             * Deal with exceptions.
             */
            $this->_helper->flashMessenger->addMessage("There was an error processing your request.");
            $this->_helper->flashMessenger->addMessage("Exception Type:".get_class($e));
            $this->_helper->flashMessenger->addMessage("Exception Message:".$e->getMessage());
            $this->_redirect('/index/index');
            return false;
        }

        return true;            

    } // public function extractAction()
    
    
    public function loginAction()
    {
        $this->view->token = $this->generateToken();
        
        $flash = $this->_helper->getHelper('flashMessenger');
        if ($flash->hasMessages()) {
            $this->view->message = implode("<br />", $flash->getMessages());            
        } // if ($flash->hasMessages()) 
        
    }
    
    
    public function registerAction()
    {
        $this->view->token = $this->generateToken();
        
        $flash = $this->_helper->getHelper('flashMessenger');
        if ($flash->hasMessages()) {
            $this->view->message = implode("<br />", $flash->getMessages());            
        } // if ($flash->hasMessages()) 
        
    }
    

} // class IndexController extends Zend_Controller_Action